#include <iostream>
#include <vector>
using namespace std;
int niz1[20];
    vector <int> mat[20];
int main()
{
int a,b,c,i,niz[200000],l,r,t,j,niz2[200000],k=0;
cin>>a>>b;
for(i=0;i<a;i++)
{
   cin>>niz[i];
}for(j=0;j<b;j++)
{

cin>>l>>r;
t=1;
for(i=l;i<=r;i++)
{
    if(niz[i-1]==0)
        t=0;

}
cout<<t;
}

}